;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = Slow game speed (Matrix-style)
;DWORD [object+12] = interval
;DWORD [object+16] = TimerID    (hardly used)
;DWORD [object+20] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)
;DWORD [object+24] = initial run once value (for re-init)

AT100MAIN:
cmp BYTE [ecx+20],3
jz RunAlreadyOnce100
	or BYTE [ecx+20],2	;set run once bit (no matter if not used)
push esi
push edi
mov edi,ecx
mov esi,[BaseData]

	cmp DWORD [edi+16],0
	jz CreateNewTimer100
	invoke KillTimer,0,DWORD [edi+16] ;kill timer (_if_ it exists)
	mov DWORD [edi+16],0	;timer must be killed because ID is not updated

CreateNewTimer100:
	invoke SetTimer,0,0,DWORD [edi+12],TimerProc_100
	test eax,eax
	jz TimerError100

	mov [LastTimerID],eax	    ;last created timer
	mov [edi+16],eax	    ;save TimerID (for kill by this function)
	mov edx,[GameSpeedVarADDR]
	mov eax,[edi+8] 	    ;slow game speed float
	mov [edx],eax		    ;set game speed to 'slow' mode
	TimerError100:
pop edi
pop esi
RunAlreadyOnce100:
ret

;----------------------------- interval procedure
TimerProc_100:
push esi
push eax
push ecx
push edx
mov esi,[BaseData]

	invoke KillTimer,0,DWORD [esp+28] ;TimerID in WM_TIMER message

	mov eax,[esp+28]	;current TimerID
	cmp eax,[LastTimerID]
	jnz NotLastTimedCall100 ;only set game speed for last object called
	cmp [LastTimerID],0
	jz NotLastTimedCall100

	mov edx,[GameSpeedVarADDR]
	mov eax,[NormalGameSpeed]
	mov [edx],eax		;back to fast speed
	mov [LastTimerID],0

NotLastTimedCall100:
pop edx
pop ecx
pop eax
pop esi
ret 16

;==========================================================
AT100_REINIT:
mov eax,[ecx+24]	;reset initial runonce value (upon level restart)
mov [ecx+20],eax
mov eax,[esp+4] 	;standard
ret 4